import java.util.*;
import java.util.concurrent.*;

public class Buffer<E> {

    private E[] buf;
    private int S, front, rear;
    private Semaphore empty, full, mutexP, mutexC;

    public Buffer(int capacity) {
	S = capacity;
	buf = (E[])new Object[S];
	front = 0;
	rear = 0;
	empty = new Semaphore(S, true);
	full = new Semaphore(S, true);
	mutexP = new Semaphore(1, true);
	mutexC = new Semaphore(1, true);
    }

    public void put(E e) throws InterruptedException {
	empty.acquire();
	mutexP.acquire();
	buf[front] = e;
	front = (front+1)%S;
	mutexP.release();
	full.release();
    }

    public E take() throws InterruptedException {
	full.acquire();
	mutexC.acquire();
	E result = buf[rear];
	rear = (rear+1)%S;
	mutexC.release();
	empty.release();
	return result;
    }
}